/*****************************************************************
 *                                                               *
 * TURTLE.H  Header for TURTLE.EXE                               *
 *                                                               *
 * Al Williams                                                   *
 *                                                               *
 *****************************************************************/
#include <graph.h>
typedef  unsigned long ulong;
typedef  unsigned int uint;

/* graphics buffer */
extern char _gbuf[64000];

/* Application data (passed to XCI commands) */
struct  udata
  {
  char *gbuf;               /* pointer to graphics buffer */
  char tbuf[4000];          /* text buffer */
  char *gptr;               /* pointer to graphics screen */
  char *tptr;               /* pointer to text screen */
  struct xycoord graphxy;   /* x,y of graphic screen */
  struct rccoord textxy;    /* x,y of text screen */
  int color;                /* color */
  long backcolor;           /* background color */
/* store[10] & store[11] are for internal use */
  char *store[12];          /* screen storage */
  unsigned int mode:1;      /* draw or move */
  unsigned int textgraph:1; /* if 1, don't exit graphic mode */
  int heading;              /* turtle heading */

/* X and Y are stored as reals too to combat rounding errors */
  double realx;
  double realy;
/* 26 variables A-Z */
  long vars[26];
/* text color */
  int tcolor;
  };

/* Application data structure */
extern struct udata appdata;
