/*****************************************************************
 *                                                               *
 * XCI.H  Header for XCI command interpreter                     *
 *                                                               *
 * Al Williams                                                   *
 *                                                               *
 *****************************************************************/
#ifndef XCI_HEADER
#define XCI_HEADER

/* type for command functions */
#define XCICMD void far

/* Pointer to command function */
typedef void (far * XCICMDP)(int cmd,char far *line,void *udata);

/* Various hooks */
extern char *xci_prompt;   /* string to prompt with */
extern FILE *xci_infile;   /* input file */
extern int xci_exitflag;   /* set to exit XCI */
extern int xci_defaultbrk; /* default break handling */
void (*xcif_prompt)();     /* function to prompt with */
void (*xcif_prehelp)();    /* function to call before help */
void (*xcif_posthelp)();   /* function to call after help */
char *(*xcif_input)();     /* function to get input */

/* main function prototype */
int command(char *dll,char *startfile,int caseflag,
            void far *ustruc,XCICMDP userfunc);

/* add command (not from DLL) */
int addcmd(char *cmdnam,XCICMDP fn);

#endif
